diff -Naur openssl-1.0.0q.orig/ssl/s3_lib.c openssl-1.0.0q/ssl/s3_lib.c
--- openssl-1.0.0q.orig/ssl/s3_lib.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/ssl/s3_lib.c	2017-04-25 16:23:41.422030171 +0200
@@ -148,7 +148,11 @@
  * OTHERWISE.
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
+
+#include <openssl/cryptlib.h>
 #include <openssl/objects.h>
 #include "ssl_locl.h"
 #include "kssl_lcl.h"
@@ -167,7 +171,7 @@
 #define SSL3_NUM_CIPHERS	(sizeof(ssl3_ciphers)/sizeof(SSL_CIPHER))
 
 /* list of available SSLv3 ciphers (sorted by id) */
-OPENSSL_GLOBAL SSL_CIPHER ssl3_ciphers[]={
+SSL_CIPHER ssl3_ciphers[]={
 
 /* The RSA ciphers */
 /* Cipher 01 */
@@ -2121,7 +2125,7 @@
 	{
 	SSL3_STATE *s3;
 
-	if ((s3=OPENSSL_malloc(sizeof *s3)) == NULL) goto err;
+	if ((s3=(SSL3_STATE *)OPENSSL_malloc(sizeof *s3)) == NULL) goto err;
 	memset(s3,0,sizeof *s3);
 	memset(s3->rrec.seq_num,0,sizeof(s3->rrec.seq_num));
 	memset(s3->wrec.seq_num,0,sizeof(s3->wrec.seq_num));
@@ -2465,7 +2469,7 @@
 		break;
 
 	case SSL_CTRL_SET_TLSEXT_STATUS_REQ_EXTS:
-		s->tlsext_ocsp_exts = parg;
+		s->tlsext_ocsp_exts = (X509_EXTENSIONS*)parg;
 		ret = 1;
 		break;
 
@@ -2475,7 +2479,7 @@
 		break;
 
 	case SSL_CTRL_SET_TLSEXT_STATUS_REQ_IDS:
-		s->tlsext_ocsp_ids = parg;
+		s->tlsext_ocsp_ids = (STACK_OF(OCSP_RESPID) *)parg;
 		ret = 1;
 		break;
 
@@ -2486,7 +2490,7 @@
 	case SSL_CTRL_SET_TLSEXT_STATUS_REQ_OCSP_RESP:
 		if (s->tlsext_ocsp_resp)
 			OPENSSL_free(s->tlsext_ocsp_resp);
-		s->tlsext_ocsp_resp = parg;
+		s->tlsext_ocsp_resp = (unsigned char*)parg;
 		s->tlsext_ocsp_resplen = larg;
 		ret = 1;
 		break;
@@ -2634,26 +2638,26 @@
 #ifndef OPENSSL_NO_DH
 	case SSL_CTRL_SET_TMP_DH:
 		{
-		DH *new=NULL,*dh;
+		DH *new_dh=NULL,*dh;
 
 		dh=(DH *)parg;
-		if ((new=DHparams_dup(dh)) == NULL)
+		if ((new_dh=DHparams_dup(dh)) == NULL)
 			{
 			SSLerr(SSL_F_SSL3_CTX_CTRL,ERR_R_DH_LIB);
 			return 0;
 			}
 		if (!(ctx->options & SSL_OP_SINGLE_DH_USE))
 			{
-			if (!DH_generate_key(new))
+			if (!DH_generate_key(new_dh))
 				{
 				SSLerr(SSL_F_SSL3_CTX_CTRL,ERR_R_DH_LIB);
-				DH_free(new);
+				DH_free(new_dh);
 				return 0;
 				}
 			}
 		if (cert->dh_tmp != NULL)
 			DH_free(cert->dh_tmp);
-		cert->dh_tmp=new;
+		cert->dh_tmp=new_dh;
 		return 1;
 		}
 		/*break; */
@@ -2712,7 +2716,7 @@
 	case SSL_CTRL_SET_TLSEXT_TICKET_KEYS:
 	case SSL_CTRL_GET_TLSEXT_TICKET_KEYS:
 		{
-		unsigned char *keys = parg;
+		unsigned char *keys = (unsigned char*)parg;
 		if (!keys)
 			return 48;
 		if (larg != 48)
@@ -3309,7 +3313,7 @@
 	clear_sys_error();
 	if (s->s3->renegotiate) ssl3_renegotiate_check(s);
 	s->s3->in_read_app_data=1;
-	ret=s->method->ssl_read_bytes(s,SSL3_RT_APPLICATION_DATA,buf,len,peek);
+	ret=s->method->ssl_read_bytes(s,SSL3_RT_APPLICATION_DATA,(unsigned char*)buf,len,peek);
 	if ((ret == -1) && (s->s3->in_read_app_data == 2))
 		{
 		/* ssl3_read_bytes decided to call s->handshake_func, which
@@ -3318,7 +3322,7 @@
 		 * and thinks that application data makes sense here; so disable
 		 * handshake processing and try to read application data again. */
 		s->in_handshake++;
-		ret=s->method->ssl_read_bytes(s,SSL3_RT_APPLICATION_DATA,buf,len,peek);
+		ret=s->method->ssl_read_bytes(s,SSL3_RT_APPLICATION_DATA,(unsigned char*)buf,len,peek);
 		s->in_handshake--;
 		}
 	else
diff -Naur openssl-1.0.0q.orig/ssl/s3_pkt.c openssl-1.0.0q/ssl/s3_pkt.c
--- openssl-1.0.0q.orig/ssl/s3_pkt.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/ssl/s3_pkt.c	2017-04-25 16:23:41.423031136 +0200
@@ -109,10 +109,13 @@
  *
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <limits.h>
 #include <errno.h>
 #define USE_SOCKETS
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include "ssl_locl.h"
 #include <openssl/evp.h>
 #include <openssl/buffer.h>
@@ -296,7 +299,7 @@
 	SSL3_RECORD *rr;
 	SSL_SESSION *sess;
 	unsigned char *p;
-	unsigned char md[EVP_MAX_MD_SIZE];
+	unsigned char md[EVP_MAX_MD_SIZE]; /* ARRAY OK 2009-09-09 alexeik */
 	short version;
 	unsigned mac_size, orig_len;
 	size_t extra;
@@ -598,7 +601,7 @@
  */
 int ssl3_write_bytes(SSL *s, int type, const void *buf_, int len)
 	{
-	const unsigned char *buf=buf_;
+	const unsigned char *buf=(const unsigned char*)buf_;
 	unsigned int n,nw;
 	int i,tot;
 
@@ -801,7 +804,7 @@
 		}
 	else
 		{
-		memcpy(wr->data,wr->input,wr->length);
+		op_memcpy(wr->data,wr->input,wr->length);
 		wr->input=wr->data;
 		}
 
@@ -1043,7 +1046,7 @@
 		else
 			n = (unsigned int)len;
 
-		memcpy(buf,&(rr->data[rr->off]),n);
+		op_memcpy(buf,&(rr->data[rr->off]),n);
 		if (!peek)
 			{
 			rr->length-=n;
@@ -1229,7 +1232,7 @@
 			}
 		else if (alert_level == 2) /* fatal */
 			{
-			char tmp[16];
+			char tmp[16]; /* ARRAY OK 2009-09-09 alexeik */
 
 			s->rwstate=SSL_NOTHING;
 			s->s3->fatal_alert = alert_descr;
diff -Naur openssl-1.0.0q.orig/ssl/s3_srvr.c openssl-1.0.0q/ssl/s3_srvr.c
--- openssl-1.0.0q.orig/ssl/s3_srvr.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/ssl/s3_srvr.c	2017-04-25 16:23:41.425029994 +0200
@@ -1434,7 +1434,7 @@
 	unsigned char *q;
 	int j,num;
 	RSA *rsa;
-	unsigned char md_buf[MD5_DIGEST_LENGTH+SHA_DIGEST_LENGTH];
+	unsigned char md_buf[MD5_DIGEST_LENGTH+SHA_DIGEST_LENGTH]; /* ARRAY OK 2009-09-09 alexeik */
 	unsigned int u;
 #endif
 #ifndef OPENSSL_NO_DH
@@ -2202,6 +2202,7 @@
 	else
 #endif
 #ifndef OPENSSL_NO_KRB5
+#error("/* ARRAY FILE PART UNUSED. RECHECK ARRAYS BEFORE USING */")
 	if (alg_k & SSL_kKRB5)
 		{
 		krb5_error_code		krb5rc;
@@ -2211,9 +2212,9 @@
 		KSSL_CTX		*kssl_ctx = s->kssl_ctx;
 		EVP_CIPHER_CTX		ciph_ctx;
 		const EVP_CIPHER	*enc = NULL;
-		unsigned char		iv[EVP_MAX_IV_LENGTH];
+		unsigned char		iv[EVP_MAX_IV_LENGTH]; /* ARRAY OK UNUSED 2009-09-09 alexeik */
 		unsigned char		pms[SSL_MAX_MASTER_KEY_LENGTH
-					       + EVP_MAX_BLOCK_LENGTH];
+					       + EVP_MAX_BLOCK_LENGTH]; /* ARRAY OK UNUSED 2009-09-09 alexeik */
 		int		     padl, outl;
 		krb5_timestamp		authtime = 0;
 		krb5_ticket_times	ttimes;
@@ -3109,6 +3110,7 @@
 	return(ssl3_do_write(s,SSL3_RT_HANDSHAKE));
 	}
 #ifndef OPENSSL_NO_TLSEXT
+#error("/* ARRAY FILE PART UNUSED. RECHECK ARRAYS BEFORE USING */")
 int ssl3_send_newsession_ticket(SSL *s)
 	{
 	if (s->state == SSL3_ST_SW_SESSION_TICKET_A)
@@ -3119,8 +3121,8 @@
 		EVP_CIPHER_CTX ctx;
 		HMAC_CTX hctx;
 		SSL_CTX *tctx = s->initial_ctx;
-		unsigned char iv[EVP_MAX_IV_LENGTH];
-		unsigned char key_name[16];
+		unsigned char iv[EVP_MAX_IV_LENGTH]; /* ARRAY OK UNUSED 2009-09-09 alexeik */
+		unsigned char key_name[16];          /* ARRAY OK UNUSED 2009-09-09 alexeik */
 
 		/* get session encoding length */
 		slen = i2d_SSL_SESSION(s->session, NULL);
diff -Naur openssl-1.0.0q.orig/ssl/ssl.h openssl-1.0.0q/ssl/ssl.h
--- openssl-1.0.0q.orig/ssl/ssl.h	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/ssl/ssl.h	2017-04-25 16:23:41.427031645 +0200
@@ -447,21 +447,21 @@
 
 	/* only really used in SSLv2 */
 	unsigned int key_arg_length;
-	unsigned char key_arg[SSL_MAX_KEY_ARG_LENGTH];
+	unsigned char key_arg[SSL_MAX_KEY_ARG_LENGTH]; /* ARRAY OK 2009-08-07 alexeik */
 	int master_key_length;
-	unsigned char master_key[SSL_MAX_MASTER_KEY_LENGTH];
+	unsigned char master_key[SSL_MAX_MASTER_KEY_LENGTH]; /* ARRAY OK 2009-08-10 alexeik */
 	/* session_id - valid? */
 	unsigned int session_id_length;
-	unsigned char session_id[SSL_MAX_SSL_SESSION_ID_LENGTH];
+	unsigned char session_id[SSL_MAX_SSL_SESSION_ID_LENGTH]; /* ARRAY OK 2009-08-10 alexeik */
 	/* this is used to determine whether the session is being reused in
 	 * the appropriate context. It is up to the application to set this,
 	 * via SSL_new */
 	unsigned int sid_ctx_length;
-	unsigned char sid_ctx[SSL_MAX_SID_CTX_LENGTH];
+	unsigned char sid_ctx[SSL_MAX_SID_CTX_LENGTH]; /* ARRAY OK 2009-08-10 alexeik */
 
 #ifndef OPENSSL_NO_KRB5
         unsigned int krb5_client_princ_len;
-        unsigned char krb5_client_princ[SSL_MAX_KRB5_PRINCIPAL_LENGTH];
+        unsigned char krb5_client_princ[SSL_MAX_KRB5_PRINCIPAL_LENGTH]; /* ARRAY OK UNUSED 2009-08-10 alexeik */
 #endif /* OPENSSL_NO_KRB5 */
 #ifndef OPENSSL_NO_PSK
 	char *psk_identity_hint;
@@ -816,7 +816,7 @@
 
 	int verify_mode;
 	unsigned int sid_ctx_length;
-	unsigned char sid_ctx[SSL_MAX_SID_CTX_LENGTH];
+	unsigned char sid_ctx[SSL_MAX_SID_CTX_LENGTH]; /* ARRAY OK 2009-08-10 alexeik */
 	int (*default_verify_callback)(int ok,X509_STORE_CTX *ctx); /* called 'verify_callback' in the SSL */
 
 	/* Default generate session ID callback. */
@@ -848,9 +848,9 @@
 	int (*tlsext_servername_callback)(SSL*, int *, void *);
 	void *tlsext_servername_arg;
 	/* RFC 4507 session ticket keys */
-	unsigned char tlsext_tick_key_name[16];
-	unsigned char tlsext_tick_hmac_key[16];
-	unsigned char tlsext_tick_aes_key[16];
+	unsigned char tlsext_tick_key_name[16]; /* ARRAY OK 2009-08-10 alexeik */
+	unsigned char tlsext_tick_hmac_key[16]; /* ARRAY OK 2009-08-10 alexeik */
+	unsigned char tlsext_tick_aes_key[16];  /* ARRAY OK 2009-08-10 alexeik */
 	/* Callback to support customisation of ticket key setting */
 	int (*tlsext_ticket_key_cb)(SSL *ssl,
 					unsigned char *name, unsigned char *iv,
@@ -1093,7 +1093,7 @@
 	/* the session_id_context is used to ensure sessions are only reused
 	 * in the appropriate context */
 	unsigned int sid_ctx_length;
-	unsigned char sid_ctx[SSL_MAX_SID_CTX_LENGTH];
+	unsigned char sid_ctx[SSL_MAX_SID_CTX_LENGTH]; /* ARRAY OK 2009-08-10 alexeik */
 
 	/* This can also be in the session once a session is established */
 	SSL_SESSION *session;
diff -Naur openssl-1.0.0q.orig/ssl/ssl3.h openssl-1.0.0q/ssl/ssl3.h
--- openssl-1.0.0q.orig/ssl/ssl3.h	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/ssl/ssl3.h	2017-04-25 16:23:41.428030934 +0200
@@ -402,15 +402,15 @@
 	long flags;
 	int delay_buf_pop_ret;
 
-	unsigned char read_sequence[8];
+	unsigned char read_sequence[8];                  /* ARRAY OK 2009-09-17 alexeik */
 	int read_mac_secret_size;
-	unsigned char read_mac_secret[EVP_MAX_MD_SIZE];
-	unsigned char write_sequence[8];
+	unsigned char read_mac_secret[EVP_MAX_MD_SIZE];  /* ARRAY OK 2009-09-17 alexeik */
+	unsigned char write_sequence[8];                 /* ARRAY OK 2009-09-17 alexeik */
 	int write_mac_secret_size;
-	unsigned char write_mac_secret[EVP_MAX_MD_SIZE];
+	unsigned char write_mac_secret[EVP_MAX_MD_SIZE]; /* ARRAY OK 2009-09-17 alexeik */
 
-	unsigned char server_random[SSL3_RANDOM_SIZE];
-	unsigned char client_random[SSL3_RANDOM_SIZE];
+	unsigned char server_random[SSL3_RANDOM_SIZE];   /* ARRAY OK 2009-09-17 alexeik */
+	unsigned char client_random[SSL3_RANDOM_SIZE];   /* ARRAY OK 2009-09-17 alexeik */
 
 	/* flags for countermeasure against known-IV weakness */
 	int need_empty_fragments;
@@ -427,9 +427,9 @@
 
 	/* storage for Alert/Handshake protocol data received but not
 	 * yet processed by ssl3_read_bytes: */
-	unsigned char alert_fragment[2];
+	unsigned char alert_fragment[2];     /* ARRAY OK 2009-09-17 alexeik */
 	unsigned int alert_fragment_len;
-	unsigned char handshake_fragment[4];
+	unsigned char handshake_fragment[4]; /* ARRAY OK 2009-09-17 alexeik */
 	unsigned int handshake_fragment_len;
 
 	/* partial write - check the numbers match */
@@ -454,7 +454,7 @@
 	/* we allow one fatal and one warning alert to be outstanding,
 	 * send close alert via the warning alert */
 	int alert_dispatch;
-	unsigned char send_alert[2];
+	unsigned char send_alert[2]; /* ARRAY OK 2009-09-17 alexeik */
 
 	/* This flag is set when we should renegotiate ASAP, basically when
 	 * there is no more data in the read or write buffers */
@@ -474,12 +474,12 @@
 
 	struct	{
 		/* actually only needs to be 16+20 */
-		unsigned char cert_verify_md[EVP_MAX_MD_SIZE*2];
+		unsigned char cert_verify_md[EVP_MAX_MD_SIZE*2]; /* ARRAY OK 2009-09-17 alexeik */
 
 		/* actually only need to be 16+20 for SSLv3 and 12 for TLS */
-		unsigned char finish_md[EVP_MAX_MD_SIZE*2];
+		unsigned char finish_md[EVP_MAX_MD_SIZE*2];      /* ARRAY OK 2009-09-17 alexeik */
 		int finish_md_len;
-		unsigned char peer_finish_md[EVP_MAX_MD_SIZE*2];
+		unsigned char peer_finish_md[EVP_MAX_MD_SIZE*2]; /* ARRAY OK 2009-09-17 alexeik */
 		int peer_finish_md_len;
 		
 		unsigned long message_size;
@@ -503,7 +503,7 @@
 		/* used for certificate requests */
 		int cert_req;
 		int ctype_num;
-		char ctype[SSL3_CT_NUMBER];
+		char ctype[SSL3_CT_NUMBER]; /* ARRAY OK 2009-09-17 alexeik */
 		STACK_OF(X509_NAME) *ca_names;
 
 		int use_rsa_tmp;
diff -Naur openssl-1.0.0q.orig/ssl/ssl_algs.c openssl-1.0.0q/ssl/ssl_algs.c
--- openssl-1.0.0q.orig/ssl/ssl_algs.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/ssl/ssl_algs.c	2017-04-25 16:23:41.428030934 +0200
@@ -56,7 +56,11 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
+
+#include <openssl/cryptlib.h>
 #include <openssl/objects.h>
 #include <openssl/lhash.h>
 #include "ssl_locl.h"
@@ -65,7 +69,9 @@
 	{
 
 #ifndef OPENSSL_NO_DES
+#ifndef NO_SINGLE_DES
 	EVP_add_cipher(EVP_des_cbc());
+#endif
 	EVP_add_cipher(EVP_des_ede3_cbc());
 #endif
 #ifndef OPENSSL_NO_IDEA
diff -Naur openssl-1.0.0q.orig/ssl/ssl_asn1.c openssl-1.0.0q/ssl/ssl_asn1.c
--- openssl-1.0.0q.orig/ssl/ssl_asn1.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/ssl/ssl_asn1.c	2017-04-25 16:23:41.433031010 +0200
@@ -82,8 +82,12 @@
  * OTHERWISE.
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <stdlib.h>
+#endif /* !OPERA_SMALL_VERSION */
+
+#include <openssl/cryptlib.h>
 #include "ssl_locl.h"
 #include <openssl/asn1_mac.h>
 #include <openssl/objects.h>
@@ -120,11 +124,11 @@
 	{
 #define LSIZE2 (sizeof(long)*2)
 	int v1=0,v2=0,v3=0,v4=0,v5=0,v7=0,v8=0;
-	unsigned char buf[4],ibuf1[LSIZE2],ibuf2[LSIZE2];
-	unsigned char ibuf3[LSIZE2],ibuf4[LSIZE2],ibuf5[LSIZE2];
+	unsigned char buf[4],ibuf1[LSIZE2],ibuf2[LSIZE2];        /* ARRAY OK 2009-09-14 */
+	unsigned char ibuf3[LSIZE2],ibuf4[LSIZE2],ibuf5[LSIZE2]; /* ARRAY OK 2009-09-14 */
 #ifndef OPENSSL_NO_TLSEXT
 	int v6=0,v9=0,v10=0;
-	unsigned char ibuf6[LSIZE2];
+	unsigned char ibuf6[LSIZE2];                             /* ARRAY OK 2009-09-14 */
 #endif
 #ifndef OPENSSL_NO_COMP
 	unsigned char cbuf;
diff -Naur openssl-1.0.0q.orig/ssl/ssl_cert.c openssl-1.0.0q/ssl/ssl_cert.c
--- openssl-1.0.0q.orig/ssl/ssl_cert.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/ssl/ssl_cert.c	2017-04-25 16:23:41.443030885 +0200
@@ -114,14 +114,17 @@
  * SUN MICROSYSTEMS, INC., and contributed to the OpenSSL project.
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 
-#include "e_os.h"
+#include <openssl/e_os.h>
 #ifndef NO_SYS_TYPES_H
 # include <sys/types.h>
 #endif
+#endif /* !OPERA_SMALL_VERSION */
 
-#include "o_dir.h"
+#include <openssl/cryptlib.h>
+/* #include "o_dir.h" */
 #include <openssl/objects.h>
 #include <openssl/bio.h>
 #include <openssl/pem.h>
@@ -148,7 +151,7 @@
 		if (ssl_x509_store_ctx_idx < 0)
 			{
 			ssl_x509_store_ctx_idx=X509_STORE_CTX_get_ex_new_index(
-				0,"SSL for verify callback",NULL,NULL,NULL);
+				0,(void*)"SSL for verify callback",NULL,NULL,NULL);
 			}
 		}
 
@@ -170,7 +173,7 @@
 		SSLerr(SSL_F_SSL_CERT_NEW,ERR_R_MALLOC_FAILURE);
 		return(NULL);
 		}
-	memset(ret,0,sizeof(CERT));
+	op_memset(ret,0,sizeof(CERT));
 
 	ret->key= &(ret->pkeys[SSL_PKEY_RSA_ENC]);
 	ret->references=1;
@@ -190,7 +193,7 @@
 		return(NULL);
 		}
 
-	memset(ret, 0, sizeof(CERT));
+	op_memset(ret, 0, sizeof(CERT));
 
 	ret->key = &ret->pkeys[cert->key - &cert->pkeys[0]];
 	/* or ret->key = ret->pkeys + (cert->key - cert->pkeys),
@@ -386,14 +389,14 @@
 	{
 	SESS_CERT *ret;
 
-	ret = OPENSSL_malloc(sizeof *ret);
+	ret = (SESS_CERT*)OPENSSL_malloc(sizeof *ret);
 	if (ret == NULL)
 		{
 		SSLerr(SSL_F_SSL_SESS_CERT_NEW, ERR_R_MALLOC_FAILURE);
 		return NULL;
 		}
 
-	memset(ret, 0 ,sizeof *ret);
+	op_memset(ret, 0 ,sizeof *ret);
 	ret->peer_key = &(ret->peer_pkeys[SSL_PKEY_RSA_ENC]);
 	ret->references = 1;
 
@@ -682,6 +685,7 @@
 	}
 #endif
 
+#ifndef OPERA_SMALL_VERSION
 /*!
  * Add a file of certs to a stack.
  * \param stack the stack to add to.
@@ -767,7 +771,7 @@
 
 	while((filename = OPENSSL_DIR_read(&d, dir)))
 		{
-		char buf[1024];
+		char buf[1024]; /* ARRAY OK 2009-09-14 */
 		int r;
 
 		if(strlen(dir)+strlen(filename)+2 > sizeof buf)
@@ -802,4 +806,5 @@
 	CRYPTO_w_unlock(CRYPTO_LOCK_READDIR);
 	return ret;
 	}
+#endif /* OPERA_SMALL_VERSION */
 
diff -Naur openssl-1.0.0q.orig/ssl/ssl_ciph.c openssl-1.0.0q/ssl/ssl_ciph.c
--- openssl-1.0.0q.orig/ssl/ssl_ciph.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/ssl/ssl_ciph.c	2017-04-25 16:23:41.444031571 +0200
@@ -140,7 +140,11 @@
  * OTHERWISE.
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
+
+#include <openssl/cryptlib.h>
 #include <openssl/objects.h>
 #ifndef OPENSSL_NO_COMP
 #include <openssl/comp.h>
@@ -536,7 +540,11 @@
 	else
 		{
 		if (i == SSL_ENC_NULL_IDX)
+#ifdef OPERA_SMALL_VERSION
+			*enc=NULL;
+#else
 			*enc=EVP_enc_null();
+#endif
 		else
 			*enc=ssl_cipher_methods[i];
 		}
@@ -997,7 +1005,7 @@
 		curr = curr->next;
 		}
 
-	number_uses = OPENSSL_malloc((max_strength_bits + 1) * sizeof(int));
+	number_uses = (int*)OPENSSL_malloc((max_strength_bits + 1) * sizeof(int));
 	if (!number_uses)
 		{
 		SSLerr(SSL_F_SSL_CIPHER_STRENGTH_SORT,ERR_R_MALLOC_FAILURE);
@@ -1131,7 +1139,7 @@
 			cipher_id = 0;
 			while (ca_list[j])
 				{
-				if (!strncmp(buf, ca_list[j]->name, buflen) &&
+				if (!op_strncmp(buf, ca_list[j]->name, buflen) &&
 				    (ca_list[j]->name[buflen] == '\0'))
 					{
 					found = 1;
@@ -1374,7 +1382,7 @@
 	 */
 	num_of_group_aliases = sizeof(cipher_aliases) / sizeof(SSL_CIPHER);
 	num_of_alias_max = num_of_ciphers + num_of_group_aliases + 1;
-	ca_list = OPENSSL_malloc(sizeof(SSL_CIPHER *) * num_of_alias_max);
+	ca_list = (const SSL_CIPHER **)OPENSSL_malloc(sizeof(SSL_CIPHER *) * num_of_alias_max);
 	if (ca_list == NULL)
 		{
 		OPENSSL_free(co_list);
@@ -1391,7 +1399,7 @@
 	 */
 	ok = 1;
 	rule_p = rule_str;
-	if (strncmp(rule_str,"DEFAULT",7) == 0)
+	if (op_strncmp(rule_str,"DEFAULT",7) == 0)
 		{
 		ok = ssl_cipher_process_rulestr(SSL_DEFAULT_CIPHER_LIST,
 			&head, &tail, ca_list);
@@ -1626,7 +1634,7 @@
 	if (buf == NULL)
 		{
 		len=128;
-		buf=OPENSSL_malloc(len);
+		buf=(char*)OPENSSL_malloc(len);
 		if (buf == NULL) return("OPENSSL_malloc Error");
 		}
 	else if (len < 128)
diff -Naur openssl-1.0.0q.orig/ssl/ssl_lib.c openssl-1.0.0q/ssl/ssl_lib.c
--- openssl-1.0.0q.orig/ssl/ssl_lib.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/ssl/ssl_lib.c	2017-04-25 16:23:41.446030149 +0200
@@ -142,10 +142,14 @@
  * OTHERWISE.
  */
 
+#ifndef OPERA_SMALL_VERSION
 #ifdef REF_CHECK
 #  include <assert.h>
 #endif
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
+
+#include <openssl/cryptlib.h>
 #include "ssl_locl.h"
 #include "kssl_lcl.h"
 #include <openssl/objects.h>
@@ -286,7 +290,7 @@
 
 	s=(SSL *)OPENSSL_malloc(sizeof(SSL));
 	if (s == NULL) goto err;
-	memset(s,0,sizeof(SSL));
+	op_memset(s,0,sizeof(SSL));
 
 #ifndef	OPENSSL_NO_KRB5
 	s->kssl_ctx = kssl_ctx_new();
@@ -324,7 +328,7 @@
 #endif
 	s->sid_ctx_length=ctx->sid_ctx_length;
 	OPENSSL_assert(s->sid_ctx_length <= sizeof s->sid_ctx);
-	memcpy(&s->sid_ctx,&ctx->sid_ctx,sizeof(s->sid_ctx));
+	op_memcpy(&s->sid_ctx,&ctx->sid_ctx,sizeof(s->sid_ctx));
 	s->verify_callback=ctx->default_verify_callback;
 	s->generate_session_id=ctx->generate_session_id;
 
@@ -391,7 +395,7 @@
 	return 0;
 	}
     ctx->sid_ctx_length=sid_ctx_len;
-    memcpy(ctx->sid_ctx,sid_ctx,sid_ctx_len);
+    op_memcpy(ctx->sid_ctx,sid_ctx,sid_ctx_len);
 
     return 1;
     }
@@ -405,7 +409,7 @@
 	return 0;
 	}
     ssl->sid_ctx_length=sid_ctx_len;
-    memcpy(ssl->sid_ctx,sid_ctx,sid_ctx_len);
+    op_memcpy(ssl->sid_ctx,sid_ctx,sid_ctx_len);
 
     return 1;
     }
@@ -441,7 +445,7 @@
 
 	r.ssl_version = ssl->version;
 	r.session_id_length = id_len;
-	memcpy(r.session_id, id, id_len);
+	op_memcpy(r.session_id, id, id_len);
 	/* NB: SSLv2 always uses a fixed 16-byte session ID, so even if a
 	 * callback is calling us to check the uniqueness of a shorter ID, it
 	 * must be compared as a padded-out ID because that is what it will be
@@ -449,7 +453,7 @@
 	if((r.ssl_version == SSL2_VERSION) &&
 			(id_len < SSL2_SSL_SESSION_ID_LENGTH))
 		{
-		memset(r.session_id + id_len, 0,
+		op_memset(r.session_id + id_len, 0,
 			SSL2_SSL_SESSION_ID_LENGTH - id_len);
 		r.session_id_length = SSL2_SSL_SESSION_ID_LENGTH;
 		}
@@ -717,7 +721,7 @@
 		ret = s->s3->tmp.finish_md_len;
 		if (count > ret)
 			count = ret;
-		memcpy(buf, s->s3->tmp.finish_md, count);
+		op_memcpy(buf, s->s3->tmp.finish_md, count);
 		}
 	return ret;
 	}
@@ -732,7 +736,7 @@
 		ret = s->s3->tmp.peer_finish_md_len;
 		if (count > ret)
 			count = ret;
-		memcpy(buf, s->s3->tmp.peer_finish_md, count);
+		op_memcpy(buf, s->s3->tmp.peer_finish_md, count);
 		}
 	return ret;
 	}
@@ -864,6 +868,7 @@
 	SSL_set_session_id_context(t,f->sid_ctx,f->sid_ctx_length);
 	}
 
+#ifdef LIBOPEAY_PKCS12_SUPPORT
 /* Fix this so it checks all the valid key/cert options */
 int SSL_CTX_check_private_key(const SSL_CTX *ctx)
 	{
@@ -908,6 +913,7 @@
 	return(X509_check_private_key(ssl->cert->key->x509,
 		ssl->cert->key->privatekey));
 	}
+#endif /* LIBOPEAY_PKCS12_SUPPORT */
 
 int SSL_accept(SSL *s)
 	{
@@ -1312,7 +1318,7 @@
 		int n;
 
 		c=sk_SSL_CIPHER_value(sk,i);
-		n=strlen(c->name);
+		n=op_strlen(c->name);
 		if (n+1 > len)
 			{
 			if (p != buf)
@@ -1320,7 +1326,7 @@
 			*p='\0';
 			return buf;
 			}
-		strcpy(p,c->name);
+		op_strcpy(p,c->name);
 		p+=n;
 		*(p++)=':';
 		len-=n+1;
@@ -1524,7 +1530,7 @@
 		return(1);
 	if (a->session_id_length != b->session_id_length)
 		return(1);
-	return(memcmp(a->session_id,b->session_id,a->session_id_length));
+	return(op_memcmp(a->session_id,b->session_id,a->session_id_length));
 	}
 
 /* These wrapper functions should remain rather than redeclaring
@@ -1553,7 +1559,7 @@
 	if (ret == NULL)
 		goto err;
 
-	memset(ret,0,sizeof(SSL_CTX));
+	op_memset(ret,0,sizeof(SSL_CTX));
 
 	ret->method=meth;
 
@@ -1571,7 +1577,7 @@
 	ret->get_session_cb=0;
 	ret->generate_session_id=0;
 
-	memset((char *)&ret->stats,0,sizeof(ret->stats));
+	op_memset((char *)&ret->stats,0,sizeof(ret->stats));
 
 	ret->references=1;
 	ret->quiet_shutdown=0;
@@ -1649,8 +1655,8 @@
 	ret->extra_certs=NULL;
 	/* No compression for DTLS */
 	if (meth->version != DTLS1_VERSION)
-		ret->comp_methods=SSL_COMP_get_compression_methods();
-
+		ret->comp_methods=(STACK_OF(SSL_COMP) *)SSL_COMP_get_compression_methods();
+ 
 	ret->max_send_fragment = SSL3_RT_MAX_PLAIN_LENGTH;
 
 #ifndef OPENSSL_NO_TLSEXT
@@ -1673,13 +1679,13 @@
 #endif
 #ifndef OPENSSL_NO_BUF_FREELISTS
 	ret->freelist_max_len = SSL_MAX_BUF_FREELIST_LEN_DEFAULT;
-	ret->rbuf_freelist = OPENSSL_malloc(sizeof(SSL3_BUF_FREELIST));
+	ret->rbuf_freelist = (struct ssl3_buf_freelist_st *)OPENSSL_malloc(sizeof(SSL3_BUF_FREELIST));
 	if (!ret->rbuf_freelist)
 		goto err;
 	ret->rbuf_freelist->chunklen = 0;
 	ret->rbuf_freelist->len = 0;
 	ret->rbuf_freelist->head = NULL;
-	ret->wbuf_freelist = OPENSSL_malloc(sizeof(SSL3_BUF_FREELIST));
+	ret->wbuf_freelist = (struct ssl3_buf_freelist_st *)OPENSSL_malloc(sizeof(SSL3_BUF_FREELIST));
 	if (!ret->wbuf_freelist)
 		{
 		OPENSSL_free(ret->rbuf_freelist);
diff -Naur openssl-1.0.0q.orig/ssl/ssl_locl.h openssl-1.0.0q/ssl/ssl_locl.h
--- openssl-1.0.0q.orig/ssl/ssl_locl.h	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/ssl/ssl_locl.h	2017-04-25 16:23:41.447031673 +0200
@@ -147,7 +147,7 @@
 #include <string.h>
 #include <errno.h>
 
-#include "e_os.h"
+#include <openssl/e_os.h>
 
 #include <openssl/buffer.h>
 #ifndef OPENSSL_NO_COMP
diff -Naur openssl-1.0.0q.orig/ssl/ssl_rsa.c openssl-1.0.0q/ssl/ssl_rsa.c
--- openssl-1.0.0q.orig/ssl/ssl_rsa.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/ssl/ssl_rsa.c	2017-04-25 16:23:41.448031241 +0200
@@ -56,7 +56,11 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
+
+#include <openssl/cryptlib.h>
 #include "ssl_locl.h"
 #include <openssl/bio.h>
 #include <openssl/objects.h>
diff -Naur openssl-1.0.0q.orig/ssl/ssl_sess.c openssl-1.0.0q/ssl/ssl_sess.c
--- openssl-1.0.0q.orig/ssl/ssl_sess.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/ssl/ssl_sess.c	2017-04-25 16:23:41.449030530 +0200
@@ -135,7 +135,11 @@
  * OTHERWISE.
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
+
+#include <openssl/cryptlib.h>
 #include <openssl/lhash.h>
 #include <openssl/rand.h>
 #ifndef OPENSSL_NO_ENGINE
@@ -195,7 +199,7 @@
 		SSLerr(SSL_F_SSL_SESSION_NEW,ERR_R_MALLOC_FAILURE);
 		return(0);
 		}
-	memset(ss,0,sizeof(SSL_SESSION));
+	op_memset(ss,0,sizeof(SSL_SESSION));
 
 	ss->verify_result = 1; /* avoid 0 (= X509_V_OK) just in case */
 	ss->references=1;
@@ -353,7 +357,7 @@
 			}
 		/* If the session length was shrunk and we're SSLv2, pad it */
 		if((tmp < ss->session_id_length) && (s->version == SSL2_VERSION))
-			memset(ss->session_id + tmp, 0, ss->session_id_length - tmp);
+			op_memset(ss->session_id + tmp, 0, ss->session_id_length - tmp);
 		else
 			ss->session_id_length = tmp;
 		/* Finally, check for a conflict */
@@ -414,7 +418,7 @@
 		SSL_SESSION_free(ss);
 		return 0;
 		}
-	memcpy(ss->sid_ctx,s->sid_ctx,s->sid_ctx_length);
+	op_memcpy(ss->sid_ctx,s->sid_ctx,s->sid_ctx_length);
 	ss->sid_ctx_length=s->sid_ctx_length;
 	s->session=ss;
 	ss->ssl_version=s->version;
@@ -500,7 +504,7 @@
 	/* Now ret is non-NULL, and we own one of its reference counts. */
 
 	if (ret->sid_ctx_length != s->sid_ctx_length
-	    || memcmp(ret->sid_ctx,s->sid_ctx,ret->sid_ctx_length))
+	    || op_memcmp(ret->sid_ctx,s->sid_ctx,ret->sid_ctx_length))
 		{
 		/* We've found the session named by the client, but we don't
 		 * want to use it in this context. */
@@ -764,7 +768,7 @@
                     session->krb5_client_princ_len > 0)
                 {
                     s->kssl_ctx->client_princ = (char *)OPENSSL_malloc(session->krb5_client_princ_len + 1);
-                    memcpy(s->kssl_ctx->client_princ,session->krb5_client_princ,
+                    op_memcpy(s->kssl_ctx->client_princ,session->krb5_client_princ,
                             session->krb5_client_princ_len);
                     s->kssl_ctx->client_princ[session->krb5_client_princ_len] = '\0';
                 }
@@ -868,7 +872,7 @@
 			s->tlsext_session_ticket = NULL;
 			}
 
-		s->tlsext_session_ticket = OPENSSL_malloc(sizeof(TLS_SESSION_TICKET_EXT) + ext_len);
+		s->tlsext_session_ticket = (TLS_SESSION_TICKET_EXT*)OPENSSL_malloc(sizeof(TLS_SESSION_TICKET_EXT) + ext_len);
 		if (!s->tlsext_session_ticket)
 			{
 			SSLerr(SSL_F_SSL_SET_SESSION_TICKET_EXT, ERR_R_MALLOC_FAILURE);
@@ -1092,4 +1096,6 @@
 	ctx->app_verify_cookie_cb=cb;
 	}
 
+#ifndef OPERA_SMALL_VERSION
 IMPLEMENT_PEM_rw(SSL_SESSION, SSL_SESSION, PEM_STRING_SSL_SESSION, SSL_SESSION)
+#endif // !OPERA_SMALL_VERSION
diff -Naur openssl-1.0.0q.orig/ssl/ssl_task.c openssl-1.0.0q/ssl/ssl_task.c
--- openssl-1.0.0q.orig/ssl/ssl_task.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/ssl/ssl_task.c	2017-04-25 16:23:41.450030098 +0200
@@ -114,6 +114,9 @@
  * Author: Dave Jones
  * Date:   22-JUL-1996
  */
+
+#error("/* ARRAY FILE UNUSED. CHECK ARRAYS BEFORE USING */")
+
 #include <stdlib.h>
 #include <stdio.h>
 #include <iodef.h>		/* VMS IO$_ definitions */
diff -Naur openssl-1.0.0q.orig/ssl/ssltest.c openssl-1.0.0q/ssl/ssltest.c
--- openssl-1.0.0q.orig/ssl/ssltest.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/ssl/ssltest.c	2017-04-25 16:23:41.451030225 +0200
@@ -140,6 +140,8 @@
  * OTHERWISE.
  */
 
+#error("/* ARRAY FILE UNUSED. CHECK ARRAYS BEFORE USING */")
+
 #define _BSD_SOURCE 1		/* Or gethostname won't be declared properly
 				   on Linux and GNU platforms. */
 
diff -Naur openssl-1.0.0q.orig/ssl/t1_clnt.c openssl-1.0.0q/ssl/t1_clnt.c
--- openssl-1.0.0q.orig/ssl/t1_clnt.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/ssl/t1_clnt.c	2017-04-25 16:23:41.452030353 +0200
@@ -56,7 +56,11 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
+
+#include <openssl/cryptlib.h>
 #include "ssl_locl.h"
 #include <openssl/buffer.h>
 #include <openssl/rand.h>
